<template>
  <div
    v-if="isShow"
    class="event-reason-select"
  >
    <ObSelect
      :value="formData.eventData ? formData.eventData.reasonUuid : ''"
      label="Причина"
      placeholder="Причина не указана"
      :items="currentReasonsList"
      :required="true"
      :disabled="disabled"
      @selected="onSelectReason"
    />
    <div
      v-if="isShowError"
      class="event-reason-select__error"
    >
      <i class="icon alert" />
      <span>Укажите причину нажав “Редактировать”</span>
    </div>
  </div>
</template>

<script>
import ObSelect from 'common-components/src/obComponents/obSelect'
import { mapGetters } from 'vuex'

export default {
  name: 'OrderEventReasonSelect',
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    eventCode: {
      type: String,
      default: () => null
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    }
  },
  components: {
    ObSelect
  },
  computed: {
    ...mapGetters({
      reasonsList: 'order/reasonsList'
    }),
    currentReasonsList () {
      return this.reasonsList[this.eventCode?.toUpperCase()] || []
    },
    isShow () {
      return Boolean(this.currentReasonsList?.length)
    },
    placeholder() {
      if (this.disabled && !this.value) return 'Причина не указана'

      return 'Выберите из списка'
    },
    isShowError () {
      return this.disabled && !this.isEditMode && !this.formData.eventData?.reasonUuid
    }
  },
  methods: {
    onSelectReason (data) {
      this.$emit('on-select', data)
    }
  },
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.event-reason-select {
  margin-bottom: 30px;
  &__error {
    display: flex;
    align-items: center;
    margin-top: 5px;
    @include font-mixin(12px, 12px, 400, $color-error, 0.4px);
    .icon {
      margin-right: 4px;
      font-weight: 900;
    }
  }
}
</style>